/*	
 * Created on 18.okt.2003
 *
 */

package com.exponto.jstock;
/**
 * Class for handling of user drawn lines.
 * 
 * @author ttranu
 *
 */

import java.util.ArrayList;
//import java.awt.geom.Line2D;

public class Lines {
	ArrayList persistentLines;
//	Line2D.Double currentLine;
	int currentPosistion;
	int activeSelection = -1;
	int type;
	int removedNumber = 0;
	TickerID tickerId;
	JstockDB jDB;
	
	
	public Lines(TickerID id, boolean isWeekly) {
//		lines = new ArrayList();
		tickerId = id;
		this.setType(isWeekly);
		persistentLines = new ArrayList();
		currentPosistion = 0;
	}

//TODO: Make a better way to save data on exit	
	public void finalize() {
		this.saveLines();
	}
	
	public void load(int tickerId) {
	}
	public void reset() {
		currentPosistion = 0;
//		currentLine = (Line2D.Double) lines.get(currentPosistion);
	}
	
	public void changeCurrentLine(int i) {
		currentPosistion = currentPosistion + i;
		
	}
//	public Line2D.Double hasNext() {
//		if (currentPosistion < lines.size()) {
//			currentLine = (Line2D.Double) lines.get(currentPosistion++);
//			return currentLine;
//		} else return null;
//	}
	
	public PersistentLine hasNext() {
		if (currentPosistion < persistentLines.size()) {
			return (PersistentLine) persistentLines.get(currentPosistion++);
		} else return null;
	}

	public PersistentLine getActive() {
		return (PersistentLine) persistentLines.get(activeSelection);
	}
	public void setActive(PersistentLine pL) {
		// TODO: Do this a little easier please (just update x1, y1, x2, y2)
		PersistentLine oldPL = (PersistentLine) persistentLines.get(activeSelection);
		pL.setDeleted(oldPL.getDeleted());
		pL.setLineIndex(oldPL.getLineIndex());
		pL.setSelected(oldPL.getSelected());
		persistentLines.set(activeSelection, pL);
	}
	
//	public void addLine(double x1, double y1, double x2, double y2, PersistentLine pL) {
//		Line2D.Double l = new Line2D.Double(x1, y1, x2, y2);
//		lines.add(l);
//		persistentLines.add(pL);
//	}
	
	public void addLine(PersistentLine pL) {
		//lines.add(line);
		persistentLines.add(pL);
	}
	
	public void removeCurrentLine() {
//		lines.remove(currentLine);
//		persistentLines.remove(currentLine);
	}

//	public void moveLine(int x, int y) {
//		PersistentLine pL = (PersistentLine) persistentLines.get(activeSelection);
//		int  select = pL.getSelected();
//	}

/**
 * 
 * @param keepSelected if false all selection is reset. 
 * @return true if a new PersistentLine is selected
 */
	public boolean selectNext(boolean keepSelected) {
		if (!keepSelected) {
			setCurrentSelection(false); 
		}
		if (persistentLines.size() == 0) {
			//No lines to select
			return false;
		}
		boolean allChecked = false; 
		PersistentLine pL;
		int currentSelection = activeSelection;
		do {
			activeSelection ++;
			if (activeSelection >= persistentLines.size()) {
				activeSelection = 0;
				allChecked = true;
			}
			pL = (PersistentLine) persistentLines.get(activeSelection);
			if (currentSelection == activeSelection) {
				// Returns without changes if all lines are selected already
				activeSelection = currentSelection;
				return false;
			}
		} while (pL.isSelected() || pL.isDeleted());
		pL.setSelected(true);
		return true;
	}

	/**
	 * 
	 * @param keepSelected if false all selection is reset. 
	 * @return true if a new PersistentLine is selected
	 */
		public boolean selectPrevious(boolean keepSelected) {
			if (!keepSelected) {
				setCurrentSelection(false); 
			}
			boolean allChecked = false; 
			PersistentLine pL;
			int currentSelection = activeSelection;
			do {
				activeSelection --;
				if (activeSelection < 0) {
					activeSelection = persistentLines.size()-1;
					allChecked = true;
				}
				pL = (PersistentLine) persistentLines.get(activeSelection);
				if (currentSelection == activeSelection) {
					// Returns without changes if all lines are selected already
					activeSelection = currentSelection;
					return false;
				}
			} while (pL.isSelected());
			pL.setSelected(true);
			return true;
		}

	public void selectNextEnd() {
		PersistentLine pL = (PersistentLine) persistentLines.get(activeSelection);
		int  select = pL.getSelected();
		select ++;
		if (select >= 3) {
			select = -1;
		}
		pL.setSelected(select);
	}

	public void deleteActiveSelection() {
		if (persistentLines.size() > 0) {
			PersistentLine pL = (PersistentLine) persistentLines.get(activeSelection);
			pL.setDeleted(removedNumber++); 			
		}

		
		//remove(activeSelection);
	}
	
	private void loadLines(int tickerId) {
		
		// Load lines from db
	}
	public void saveLines() {
//		Save Lines to the database
		jDB = JstockDB.getInstance();
		this.persistentLines = jDB.saveLines(this);
		this.reset();
		  
	}
		
	/**
	 * @return the TickerId
	 */
	public TickerID getTickerId() {
		return tickerId;
	}

	/**
	 * @return the type (either daily or weekly)
	 */
	public int getType() {
		return type;
	}

	/**
	 * @param id The TickerId
	 */
	public void setTickerId(TickerID id) {
		tickerId = id;
	}

	/**
	 * @param isWeekly boolean that indicates of this is lines for a weekly chart or not.
	 */
	public void setType(boolean isWeekly) {
		if (isWeekly) {
			type = Constants.weeklyLogChart;
		} else {
			type = Constants.dailyLogChart;
		}
	}

	private void setCurrentSelection(boolean select) {
		this.reset();
		PersistentLine pL;
		pL = this.hasNext();
		while (pL != null) {
			pL.setSelected(select);
			pL = this.hasNext();
		}
	}
}
