/*
 *                                 jStock
 *                    (C) Copyright 2004, Kaare Ranum
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials
 *      provided with the distribution.
 *
 *   3. Neither the name of Ex Ponto nor the names of its of its
 *      contributors may be used to endorse or promote products
 *      derived from this software without specific prior written
 *      permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


/*
 * Created on 18-Feb-2004
 *
 */
package com.exponto.jstock.popupwindows;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import com.exponto.jstock.UserPreferences;
import com.exponto.util.*;
/**
 * Generates the content for the File input tab in the Options menu.
 * 
 * @author kaare
 *
 */
public class FileInputMenu {
	JComponent [][] compArray;
	private JLabel enableNetfonds;
	private JCheckBox enableNetfondsBox;

	private JLabel date;
	private JTextField dateInput;
	private JLabel dateFormat;
	private JTextField dateFormatInput;
	private JLabel ticker;
	private JTextField tickerInput;
	private JLabel exch;
	private JTextField exchInput;
	private JLabel open;
	private JTextField openInput;
	private JLabel high;
	private JTextField highInput;
	private JLabel low;
	private JTextField lowInput;
	private JLabel close;
	private JTextField closeInput;
	private JLabel volume;
	private JTextField volumeInput;

	private TableLayoutPanel tP;
	private JPanel fileInputPanel; 
	
	int rows = 9;
	int columns = 2;
	UserPreferences userPref;
//	static Dimension threeDigitDim = new Dimension(36, 14);	
	
	public FileInputMenu() {
		//System.out.println("Jlabel: " + rsi.toString());
		//System.out.println("JTextField: " + rsiText.toString());
		initComponents();
		initCompArray();	
	}

	public JPanel getPanel() {
		fileInputPanel = new JPanel();
		fileInputPanel.setLayout(new BorderLayout());
		JPanel checkBoxPanel = new JPanel();
		checkBoxPanel.setLayout(new FlowLayout());
		checkBoxPanel.add(enableNetfonds);
		checkBoxPanel.add(enableNetfondsBox);
		fileInputPanel.add(checkBoxPanel, BorderLayout.NORTH);
		tP = new TableLayoutPanel(compArray);
		
		enableNetfondsBox.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				userPref.setEnablePos(!userPref.getEnablePos());
				if (userPref.getEnablePos()) {
					fileInputPanel.add(tP, BorderLayout.CENTER);	
				} else {
					fileInputPanel.remove(tP);
				}
				// Redraws the panel.
				fileInputPanel.revalidate();
				//System.out.println(" Trykker p knappen og n er den " + userPref.getEnablePos());

			}
		});
		
		tP.setOpaque(true);
		fileInputPanel.setOpaque(true);
		if (userPref.getEnablePos()) {
			fileInputPanel.add(tP, BorderLayout.CENTER);	
		}
		fileInputPanel.revalidate();
		return fileInputPanel;
	}
	public void save() {
		userPref.setTickerPos(tickerInput.getText());
		userPref.setExchangePos(exchInput.getText());
		userPref.setDatePos(dateInput.getText());
		userPref.setOpenPos(openInput.getText());
		userPref.setHighPos(highInput.getText());
		userPref.setLowPos(lowInput.getText());
		userPref.setClosePos(closeInput.getText());
		userPref.setVolumePos(volumeInput.getText());
	}
	public void restore() {
		
		tickerInput.setText(String.valueOf(userPref.getTickerPos()));
		exchInput.setText(String.valueOf(userPref.getExchangePos()));
		dateInput.setText(String.valueOf(userPref.getDatePos()));
		openInput.setText(String.valueOf(userPref.getOpenPos()));
		highInput.setText(String.valueOf(userPref.getHighPos()));
		lowInput.setText(String.valueOf(userPref.getLowPos()));
		closeInput.setText(String.valueOf(userPref.getClosePos()));
		volumeInput.setText(String.valueOf(userPref.getVolumePos()));	

	}
	
	private void initComponents() {
		userPref = UserPreferences.getInstance();
		enableNetfonds = new JLabel("Use column position");
		enableNetfondsBox = new JCheckBox("Check to enable", userPref.getEnablePos());
		
		ticker = new JLabel("Column number for ticker");
		tickerInput = new JTextField(String.valueOf(userPref.getTickerPos()), 3);
		exch = new JLabel("Column number for exchange");
		exchInput = new JTextField(String.valueOf(userPref.getExchangePos()), 3);
		date = new JLabel("Column number for date");
		dateInput = new JTextField(String.valueOf(userPref.getDatePos()), 3);
		dateFormat= new JLabel("Format of date");
		dateFormatInput = new JTextField(userPref.getDateFormat(), 10);
		open = new JLabel("Column number for open");
		openInput = new JTextField(String.valueOf(userPref.getOpenPos()), 3);
		high = new JLabel("Column number for high");
		highInput = new JTextField(String.valueOf(userPref.getHighPos()), 3);
		low = new JLabel("Column number for low");
		lowInput = new JTextField(String.valueOf(userPref.getLowPos()), 3);
		close = new JLabel("Column number for close");
		closeInput = new JTextField(String.valueOf(userPref.getClosePos()), 3);
		volume = new JLabel("Column number for volume");
		volumeInput = new JTextField(String.valueOf(userPref.getVolumePos()), 3);

		
//		String rsiTip = "Enter the number of days to use in RSI calculation. \nUse 0 for no RSI.";
//		String maTip = "Enter the number of days to use in moving average calculation. \nUse 0 for no moving average.";
		
		//
		this.restore();
//		rsiText.setToolTipText(rsiTip);
//		rsi.setToolTipText(rsiTip);
		
//		maText.setToolTipText(maTip);
//		ma.setToolTipText(maTip);
		//maText.setPreferredSize(threeDigitDim);
//		rsiText.setPreferredSize(threeDigitDim);
	}
	
	private void initCompArray() {
		compArray = new JComponent[rows][];
		for (int i = 0; i < rows; i ++) {
			compArray[i] = new JComponent[columns]; 
		}
		compArray[0][0] = date;
		compArray[0][1] = dateInput;
		compArray[1][0] = ticker;
		compArray[1][1] = tickerInput;
		compArray[2][0] = exch;
		compArray[2][1] = exchInput;
		compArray[3][0] = open;
		compArray[3][1] = openInput;
		compArray[4][0] = high;
		compArray[4][1] = highInput;
		compArray[5][0] = low;
		compArray[5][1] = lowInput;
		compArray[6][0] = close;
		compArray[6][1] = closeInput;
		compArray[7][0] = volume;
		compArray[7][1] = volumeInput;
		compArray[8][0] = dateFormat;
		compArray[8][1] = dateFormatInput;
		
		
	}
}
