/*
 *                                 jStock
 *                    (C) Copyright 2004, Kaare Ranum
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials
 *      provided with the distribution.
 *
 *   3. Neither the name of Ex Ponto nor the names of its of its
 *      contributors may be used to endorse or promote products
 *      derived from this software without specific prior written
 *      permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


/*
 * Created on 18-Feb-2004
 *
 */
package com.exponto.jstock.popupwindows;
import javax.swing.*;
import javax.swing.table.*;
//import java.awt.*;
//import com.exponto.jstock.UserPreferences;

/**
 * @author kaare
 *
 */
public class RulesMenu {

	//JPanel tablePanel;
	JScrollPane tablePane;
	JTable rulesTable;
	RulesTableModel rulesTableModel;
	
	TableColumn firstIndColumn;
	TableColumn firstOpColumn;
	TableColumn secondIndColumn;
	TableColumn secondOpColumn;
	
	JComboBox operatorCombo;
	JComboBox indicatorsCombo;
	
	public RulesMenu() {
		initComponents();
	}

	public JScrollPane getRulesPane() {
		
//		TableLayoutPanel tP = new TableLayoutPanel(compArray);
//		tP.setOpaque(true);
		return tablePane;
	}
	public void save() {
	}
	public void restore() {
		
	}
	
	private void initComponents() {
		rulesTableModel = new RulesTableModel();
		rulesTable = new JTable(rulesTableModel);
		tablePane = new JScrollPane(rulesTable);

		// Setting up cell editors
		operatorCombo = new JComboBox();
		for (int i = 0; i < Constants.operators.length; i++) {
			operatorCombo.addItem(Constants.operators[i]);
		}
		indicatorsCombo = new JComboBox();
		for (int i = 0; i < Constants.indicators.length; i++) {
			indicatorsCombo.addItem(Constants.indicators[i]);
		}
		
		firstIndColumn = rulesTable.getColumnModel().getColumn(1);
		firstOpColumn = rulesTable.getColumnModel().getColumn(2);
		secondIndColumn = rulesTable.getColumnModel().getColumn(4);
		secondOpColumn = rulesTable.getColumnModel().getColumn(5);
		
		firstIndColumn.setCellEditor(new DefaultCellEditor(indicatorsCombo));
		firstOpColumn.setCellEditor(new DefaultCellEditor(operatorCombo));
		secondIndColumn.setCellEditor(new DefaultCellEditor(indicatorsCombo));
		secondOpColumn.setCellEditor(new DefaultCellEditor(operatorCombo));
		//table
	}
	

}
