/*
 *                                 jStock
 *                    (C) Copyright 2004, Kaare Ranum
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials
 *      provided with the distribution.
 *
 *   3. Neither the name of Ex Ponto nor the names of its of its
 *      contributors may be used to endorse or promote products
 *      derived from this software without specific prior written
 *      permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


/*
 * Created on 18-Feb-2004
 *
 */
package com.exponto.jstock.popupwindows;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import com.exponto.jstock.UserPreferences;
import com.exponto.util.*;
/**
 * @author kaare
 *
 */
public class SystemMenu {
	JComponent [][] compArray;

	private JLabel filePath;
	private JTextField filePathInput;
	private JButton filePathBrowse;
	
	private JLabel extension;
	private JTextField extensionInput;
	private JLabel exchange;
	private JTextField exchangeInput;
	private JLabel pixelsPerStick;
	private JTextField pixelsPerStickInput;

	private TableLayoutPanel tP;
	private JPanel mainPanel;
	private JPanel chooserPanel;
	
	int rows = 3;
	int columns = 2;
	UserPreferences userPref;
//	static Dimension threeDigitDim = new Dimension(36, 14);	
	
	public SystemMenu() {
		//System.out.println("Jlabel: " + rsi.toString());
		//System.out.println("JTextField: " + rsiText.toString());
		initComponents();
		initCompArray();	
	}

	public JPanel getPanel() {
		mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());
		chooserPanel = new JPanel();
		chooserPanel.setLayout(new FlowLayout());
		chooserPanel.add(filePathBrowse);
		filePathBrowse.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				filePath();
			}
		});

		
		tP = new TableLayoutPanel(compArray);
		tP.setOpaque(true);
		
		mainPanel.add(chooserPanel, BorderLayout.EAST);
		mainPanel.add(tP, BorderLayout.CENTER);
		return mainPanel;
	}
	public void save() {
		userPref.setFilePath(filePathInput.getText());
		userPref.setExtension(extensionInput.getText());
		userPref.setExchange(exchangeInput.getText());
		userPref.setPixelPrStick(pixelsPerStickInput.getText());
	}
	public void restore() {
		filePathInput.setText(userPref.getFilePath());
		extensionInput.setText(userPref.getExtension());
		exchangeInput.setText(userPref.getExtension());
		pixelsPerStickInput.setText(String.valueOf(userPref.getPixelPrStick()));
	}
	
	private void initComponents() {
		userPref = UserPreferences.getInstance();
		
		filePath = new JLabel("File path");
		filePathInput = new JTextField(userPref.getFilePath());
		filePathBrowse = new JButton("Browse path");	
		extension = new JLabel("Extension");
		extensionInput = new JTextField(userPref.getExtension());
		exchange = new JLabel("Exchange");
		exchangeInput = new JTextField(userPref.getExchange());
		//filePathBrowse = new JButton("Browse");
		pixelsPerStick = new JLabel("Pixels per stick");
		pixelsPerStickInput = new JTextField(String.valueOf(userPref.getPixelPrStick()));
		
		String pathTip = "Shall contain the path to the quote files, including prefix part of the filename. See doc. for details";
		String pixelTip = "Enter the width of the candlestick in pixels. Minimum is 4.";
				
		//
		this.restore();
		filePath.setToolTipText(pathTip);
		filePathInput.setToolTipText(pathTip);
		filePathBrowse.setToolTipText(pathTip);
		pixelsPerStick.setToolTipText(pixelTip);
		pixelsPerStickInput.setToolTipText(pixelTip);

		
	}
	private void filePath() {
		JFileChooser chooser = new JFileChooser();
		int returnVal = chooser.showOpenDialog(mainPanel);
		if(returnVal == JFileChooser.APPROVE_OPTION) {
//			filePathInput.setText(chooser.getSelectedFile().getName());
			filePathInput.setText(chooser.getSelectedFile().getPath());
		}
	}
	
	
	private void initCompArray() {
		compArray = new JComponent[rows][];
		for (int i = 0; i < rows; i ++) {
			compArray[i] = new JComponent[columns]; 
		}
		compArray[0][0] = filePath;
		compArray[0][1] = filePathInput;
		compArray[1][0] = extension;
		compArray[1][1] = extensionInput;
		compArray[2][0] = pixelsPerStick;
		compArray[2][1] = pixelsPerStickInput;
		
	}
}
